/****************************************************************************
*
*	  Module Filename:  Kernel_Manager.cpp
*	  Module Name:      Kernel_Manager
*	  Description:      SimSoup Kernel Manager
*                      
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*	  Amendment History:-
*
*         Version    Date                 Update Description
*         =======    ===========          ==================
*
*
*
*
****************************************************************************/

#include    "globldef.h"
#include    "Library_Headers.h"

namespace DN {
#include "list.hpp"        // Special purpose - Non STL
}

//---------------- Kernel Manager Subsystem  ---------------------------------------------------------------------
#include  "Kernel_Manager.h"
#include  "Krnl_Vis.h"
#include  "Krnl_Ctrl.h"
#include  "Simulation_Scheduler.h"
//----------------------------------------------------------------------------------------------------------------

//----------------Statistics Subsystem  --------------------------------------------------------------------------
#include    "Simulation_Statistics.h"
//----------------------------------------------------------------------------------------------------------------

//------------------  Simulation Subsystem -----------------------------------------------------------------------
#include "Scenario_Manager.h"
#include "Attribute.h"
//----------------------------------------------------------------------------------------------------------------

//--------------  Chemistry  Subsystem  --------------------------------------------------------------------------
#include    "Chemistry.h"
//----------------------------------------------------------------------------------------------------------------

//--------------  Reactor  Subsystem  ----------------------------------------------------------------------------
#include    "Reactor.h"
//----------------------------------------------------------------------------------------------------------------


Kernel_Manager::Kernel_Manager()
{

}
//----------------------------------------------------------------------------------------------------------------

void Kernel_Manager::Start()

//  Start the SimSoup Kernel and initialise its API

{
    using namespace Attribute;
    Simulation_Scheduler::Make();
    Chemistry::Make();
    Reactor::Make();
    AttrNames::Make();
    Scenario_Manager::Make();
    Krnl_Vis::Initialise_API();
    Krnl_Ctrl::Initialise_API();
}
//----------------------------------------------------------------------------------------------------------------

void  Kernel_Manager::Stop()

{

}
//----------------------------------------------------------------------------------------------------------------
