/****************************************************************************
*
*	  Header Filename:  Molecule.h
*	  Module Name:      Molecule
*	  Description:      Molecule
*	  Author:   		Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

#ifndef Molecule_H
#define Molecule_H

class   Realised_Molecule_Type;
class   Molecule_Type;
class   Tracker;

class  Molecule
{

//      Friend Classes and Functions

    private:
//======Relationships with other classes ===================================================================

        Realised_Molecule_Type*     Realised_Molecule_Type__Ptr;
        const Molecule_Type*        Molecule_Type__Ptr;
        list<Tracker*>*  List_Of_Attached_Trackers_Ptr;
//==========================================================================================================

    public:

        const Molecule_Type*  Get_Molecule_Type_Ptr();
        Molecule(Realised_Molecule_Type* const R_Mol_Type_Ptr, double Tracker_Probability);
 //       Molecule(Realised_Molecule_Type* R_Mol_Type_Ptr,  list<Tracker*>* Tracker_List_Ptr);
        list<Tracker*>* Get_Tracker_List_Ptr();
        void   Attach_Tracker_List(list<Tracker*>* Tracker_List_Ptr);
};


#endif  //Molecule_H

