/****************************************************************************
*
*	  Header Filename:  Tracker_Manager.h
*	  Module Name:      Tracker_Manager
*	  Description:      Manage a Reactor's Trackers
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version	  Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef Tracker_Manager_H
#define Tracker_Manager_H

class  Tracker;
class  Realised_Cycle_Type_Manager;

class   Tracker_Manager

{
//===== Relationships with other classes ===================================================================
    private:
        list<Tracker*>  List_Of_Trackers;
        Realised_Cycle_Type_Manager*  RCT_Manager_Ptr;
//==========================================================================================================

    public:
        Realised_Cycle_Type_Manager*  Get_Realised_Cycle_Type_Manager_Ptr() {return  RCT_Manager_Ptr;};
        void      Remove_Tracker(Tracker*  Tracker_Ptr);
        Tracker*  Add_Tracker();
        static int   Get_Num_Trackers();
        void      List_Trackers();
        Tracker_Manager (Realised_Cycle_Type_Manager*  RCT_Manager_Ptr);
        void Clear();
        static Tracker_Manager*  Get_Pt();
    private:
        static int       Number_Of_Trackers;
        static Tracker_Manager*  Instance_Pt;
};
#endif  //Tracker_Manager_H
