/****************************************************************************
*
*     Module Filename:  Drawing_Area.h
*     Module Name:      Drawing_Area
*     Description:      Drawing Area for the SimSoup Display
*                      
*     Author:           Chris Gordon-Smith
*
*     Copyright (C) 2007, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License as published by the
*     Free Software Foundation; either version 2 of the License, or (at your
*     option) any later version.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*      Amendment History:- 
*
*              Version    Date                        Update Description
*              =======    ===========                 ==================
*
*
*
*
****************************************************************************/

#ifndef DRAWING_AREA_H
#define DRAWING_AREA_H

class   Drawing_Area : public Gtk::DrawingArea

{
//===== Relationships with other classes ===================================================================

//==========================================================================================================

    public:
        void Clear();
        Drawing_Area();
        void Draw_Line(int X1, int Y1, int X2, int Y2);
        void Draw_Pixmap();
        void Draw_Rectangle(bool Filled, int X, int  Y, int Width, int Height);
        void Get_Size (int& Width, int&  Height);
        void Set_Foreground_Colour(Gdk::Color  GDK_Colour);
        void Set_Foreground_Colour(int Red, int Green, int Blue);
        void Text_Out(int X, int Y, string Text);
        virtual ~Drawing_Area() {};
             
    protected:
        //Overridden default signal handlers:
        virtual void on_realize();
        virtual bool on_expose_event(GdkEventExpose* event);
            
    private:
        Glib::RefPtr<Gdk::Window> GDK_Window; // Window for the Drewing Area. The Pixmap is drawn on the Window
        Glib::RefPtr<Gdk::Pixmap>  GDK_Pixmap;  //  Pixmap on which the statistics display is built tup 
        Glib::RefPtr<Gdk::GC>  GDK_Context;  
        bool  Realised;
};
#endif  //DRAWING_AREA_H
